//********************************************************************
//**Closing windows using Topic()*************************************
//********************************************************************
client
	Topic(href,href_list[])
		..()
		if(href_list["base_close"])
			mob << browse(null,"window=[href_list["base_close"]]")
mob/proc/base_closewindow(window as text)
	if(client && istext(window))
		client.Topic(null,list("base_close" = "[window]"))

//********************************************************************
//**Log in/out messages***********************************************
//********************************************************************
#if !defined(BASE_LOGIN_MESSAGE)
#define BASE_LOGIN_MESSAGE(mob) "[mob] logs in."
#endif

#if !defined(BASE_LOGOUT_MESSAGE)
#define BASE_LOGOUT_MESSAGE(mob) "[mob] logs out."
#endif

mob
	Login()
		..()
		var/message = BASE_LOGIN_MESSAGE(src)
		if(message) world << message
	Logout()
		..()
		var/message = BASE_LOGOUT_MESSAGE(src)
		if(message) world << message
//********************************************************************
//**Host verbs********************************************************
//********************************************************************
#if defined(BASE_INC_HOST)
mob
	Login()
		..()
		if("[key]" in base_banlist)
			src << "You are banned from this server."
			spawn() Logout()
		if(client && client.address in list(null, world.address))
			verbs += typesof(/Host/proc)


client
	Topic(href,href_list[])
		..()
		if(href_list["base_boot"])
			var/mob/boot
			for(var/mob/M in world)
				if(M.client && M.key == href_list["base_boot"]) boot = M
			if(!boot) return .
			var
				reason = list("Spam","Insulting","Foul Language",\
				   "Bug abuser","Other","Cancel")
				picked = input("Reason?","Boot") in reason
			if(picked == "Cancel")
				mob.base_closewindow("boot_window")
				return .
			if(boot == mob)
				mob << "Don't boot yourself."
				return .
			world<<"[src] booted [boot]. Reason: [picked]."
			del boot
			mob.base_closewindow("boot_window")
			return .
		if(href_list["base_ban"])
			var/mob/ban
			for(var/mob/M in world)
				if(M.client && M.key == href_list["base_ban"]) ban = M
			if(!ban) return .
			else if("[ban]" in base_banlist) mob << "Player is already banned."
			else if("[mob]" == "[ban]") mob << "Don't ban yourself."
			else
				base_banlist += "[ban]"
				world << "[src] banned [ban]."
				del ban
				mob.base_closewindow("ban_window")
				return .
		if(href_list["base_unban"])
			while(base_banlist.Find("[href_list["base_unban"]]"))
				base_banlist -= "[href_list["base_unban"]]"
			world << "[src] unbanned the key: [href_list["base_unban"]]."
			mob.base_closewindow("unban_window")
			return .


#if !defined(BASE_BOOT_CSS)
#define BASE_BOOT_CSS {"body {background: #0000FF;} \
.title {color: #FFFFFF; text-align: center;} \
.mob {color: 0099AA;} .close {color: #FF0000; font-style: italic;}"}
#endif

#if !defined(BASE_BAN_CSS)
#define BASE_BAN_CSS {"body {background: #0000FF;} \
.title {color: #FFFFFF; text-align: center;} \
.mob {color: 0099AA;} .close {color: #FF0000; font-style: italic;}"}
#endif

var/list/base_banlist[0]

Host
	proc
		Boot()
			set category="Host"
			var
				html = {"<style type=text/css>[BASE_BOOT_CSS]</style>
<title>Boot</title><br><br><h2 class='title'>Boot</h2>"}
			for(var/mob/M in world)
				if(M.client)
					html += \
					   "<br><a href=?base_boot=[M.key] class='mob'>[M]</a>"
			html+="<br><a href=?base_close=boot_window class='close'>Close</a>"
			src << browse(html,"window=boot_window;titlebar=0;can_resize=0")
		Ban()
			set category="Host"
			var
				html = {"<style type=text/css>[BASE_BAN_CSS]</style>
<title>Boot</title><br><br><h2 class='title'>Ban</h2>"}
			for(var/mob/M in world)
				if(M.client)
					html += \
					   "<br><a href=?base_ban=[M.key] class='mob'>[M]</a>"
			html += "<br><a href=?base_close=ban_window class='close'>Close</a>"
			src << browse(html,"window=ban_window;titlebar=0;can_resize=0")
		Add_Banned_Key()
			set category="Host"
			var/ban = input("What key would you like to ban?","Ban") as text
			if(!ban) return .
			else if("[ban]" in base_banlist) src << "Player is already banned."
			else if("[src]" == "[ban]") src << "Don't ban yourself."
			else
				base_banlist += "[ban]"
				world << "[src] banned [ban]."
				for(var/mob/M in world)
					if(M.client && M.key == ban) del M
		UnBan()
			set category="Host"
			var
				html = {"<style type=text/css>[BASE_BAN_CSS]</style>
<title>Boot</title><br><br><h2 class='title'>UnBan</h2>"}
			for(var/mob in base_banlist)
				html += \
				   "<br><a href=?base_unban=[mob] class='mob'>[mob]</a>"
			html+="<br><a href=?base_close=unban_window class='close'>Close</a>"
			src << browse(html,"window=unban_window;titlebar=0;can_resize=0")
#endif
//********************************************************************
//**Say verb**********************************************************
//********************************************************************
#if !defined(BASE_SAY_FORM)
#define BASE_SAY_FORM(mob,text) "\
[mob.generate_pm_text()]<b>[mob.key]</b>: [text]"
#endif

#if !defined(BASE_PM_LINKCOLOUR)
#define BASE_PM_LINKCOLOUR "#0000FF"
#endif

#if !defined(BASE_PM_LINK)
#define BASE_PM_LINK "PM-"
#endif

#if defined(BASE_INC_SAY)
mob
	verb
		Say(T as text)
			set category = null
			world << BASE_SAY_FORM(src,T)
#endif

mob
	proc
		generate_pm_text()
			return {"<style type="text/css">\
A:link, A:visited {color: [BASE_PM_LINKCOLOUR];}\
</style>\
<a href='?src=\ref[src];BASE_PM=[key]'>[BASE_PM_LINK]</a>"}

	Topic(href,href_list[])
		..()
		if(href_list["BASE_PM"])
			var/person = href_list["BASE_PM"]
			if(!person) return
			if(person == "[key]") return
			for(var/mob/M in world)
				if(M.client && M.key == person)
					var/prvt_txt = input(src,\
					"What would you like to say to [M.key]?",\
					"Private Message") as null|text
					if(!prvt_txt) return
					src << "-->[generate_pm_text()]<b>[M.key]</b>: [prvt_txt]"
					M << "<--[generate_pm_text()]</a><b>[key]</b>: [prvt_txt]"
//********************************************************************
//**Who verb**********************************************************
//********************************************************************
#if !defined(BASE_WHO_FORM)
#define BASE_WHO_FORM(mob) "<font color=#0000FF>  -</font>  \
<font color=#A9A9A9><u>[mob.key]</u></font>"
#endif

#if defined(BASE_INC_WHO)
mob
	verb
		Who()
			set category = "World"
			src << "<font color=#0000FF><b>People in world:</b></font>"
			for(var/mob/M in world)
				if(M.client)
					src << BASE_WHO_FORM(M)
#endif
//********************************************************************
//**Whois verb********************************************************
//********************************************************************
#if defined(BASE_INC_WHOIS)
mob
	verb
		Whois(M as text)
			set category = null
			src << link("http://developer.byond.com/people/[M]")
#endif
//********************************************************************
//Double-log prevent**************************************************
//********************************************************************
#if defined(BASE_NO_DOUBLELOG)
mob
	Login()
		for(var/mob/M in world)
			if(M.client && M != src)
				if(M.key == key || M.client.address == client.address)
					src << \
					  "<TT><font color=#FF0000>No double logging.</font><TT>"
					del src
		..()
#endif
//********************************************************************
//**Me verb***********************************************************
//********************************************************************
#if defined(BASE_INC_ME)
mob
	verb
		me(action as text)
			set category = null
			world << "[key] [action]"
#endif
//********************************************************************
//Help bots.**********************************************************
//********************************************************************
#if defined(BASE_INC_BOT)
var/HelpBot/help_bot = new

HelpBot
	proc
		Get_Name()
			return "<b><font color=#0000FF>Help Bot</font></b>"
		Process_Help_Query(query as text, list/split)
			return null

#if !defined(BASE_BOT_SAY)
#define BASE_BOT_SAY(Text) "[help_bot.Get_Name()]: [Text]"
#endif

#if !defined(BASE_BOT_ANSWER_COLOUR)
#define BASE_BOT_ANSWER_COLOUR "#0000FF"
#endif

mob
	Login()
		. = ..()
#if defined(BASE_BOT_LOGINMESSAGE)
		if(client)
			src << BASE_BOT_SAY(BASE_BOT_LOGINMESSAGE(src))
#endif

#if defined(BASE_INC_BOT_HELP)
mob
	verb
		Ask_Help_Bot()
			set category = "World"
			var
				question = input(\
				    "What would you like to ask the help bot about?",\
				    "Help bot") as text
				found = FALSE
				list
					split = new
			question = lowertext(question)
			while(findtext(question," "))
				split += copytext(question,1,findtext(question," "))
				question = copytext(question,findtext(question," ")+1)
			split += question
			for(var/query in split)
				if(help_bot.Process_Help_Query(query,split))
					found = TRUE
					var/message = \
					"<font color=[BASE_BOT_ANSWER_COLOUR]>[query]</font> \
[help_bot.Process_Help_Query(query)]"
					src << BASE_BOT_SAY(message)
			if(!(found))
				src << BASE_BOT_SAY("I'm sorry, \
I don't know anything matching your query.")
#endif

#endif